]> git.ipfire.org Git - people/pmueller/ipfire-2.x.git/blob - make.sh
Dem Silvio ein Applejuice/Java-Paket gebaut. Bitte testen.
[people/pmueller/ipfire-2.x.git] / make.sh
1 #!/bin/bash
2 ############################################################################
3 # #
4 # This file is part of the IPFire Firewall. #
5 # #
6 # IPFire is free software; you can redistribute it and/or modify #
7 # it under the terms of the GNU General Public License as published by #
8 # the Free Software Foundation; either version 2 of the License, or #
9 # (at your option) any later version. #
10 # #
11 # IPFire is distributed in the hope that it will be useful, #
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of #
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14 # GNU General Public License for more details. #
15 # #
16 # You should have received a copy of the GNU General Public License #
17 # along with IPFire; if not, write to the Free Software #
18 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19 # #
20 # Copyright (C) 2007 IPFire-Team <info@ipfire.org>. #
21 # #
22 ############################################################################
23 #
24
25 NAME="IPFire" # Software name
26 SNAME="ipfire" # Short name
27 VERSION="2.0t4" # Version number
28 SLOGAN="www.ipfire.org" # Software slogan
29 CONFIG_ROOT=/var/ipfire # Configuration rootdir
30 NICE=10 # Nice level
31 MAX_RETRIES=1 # prefetch/check loop
32 KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
33 MACHINE=`uname -m`
34 SVN_REVISION=`svn info | grep Revision | cut -c 11-`
35
36 IPFVER="full" # Which versions should be compiled? (full|light|devel)
37
38 # Set an information about the build number
39 if [ -e ./.svn ]; then
40 FIREBUILD=`cat .svn/entries |sed -n 's/^[ \t]*revision=\"// p' | sed -n 's/\".*$// p'`
41 fi
42
43 # Debian specific settings
44 if [ ! -e /etc/debian_version ]; then
45 FULLPATH=`which $0`
46 else
47 if [ -x /usr/bin/realpath ]; then
48 FULLPATH=`/usr/bin/realpath $0`
49 else
50 echo "ERROR: Need to do apt-get install realpath"
51 exit 1
52 fi
53 fi
54
55 PWD=`pwd`
56 BASENAME=`basename $0`
57 BASEDIR=`echo $FULLPATH | sed "s/\/$BASENAME//g"`
58 LOGFILE=$BASEDIR/log/_build.preparation.log
59 export BASEDIR LOGFILE
60 DIR_CHK=$BASEDIR/cache/check
61 mkdir $BASEDIR/log/ 2>/dev/null
62
63 # Include funtions
64 . tools/make-functions
65
66 if [ -f .config ]; then
67 . .config
68 else
69 echo -e "${BOLD}No configuration found!${NORMAL}"
70 echo -ne "Do you want to create one (y/N)?"
71 read CREATE_CONFIG
72 echo ""
73 if [ "$CREATE_CONFIG" == "y" ]; then
74 make_config
75 fi
76 fi
77
78 prepareenv() {
79 ############################################################################
80 # #
81 # Are we running the right shell? #
82 # #
83 ############################################################################
84 if [ ! "$BASH" ]; then
85 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
86 fi
87
88 if [ -z "${BASH_VERSION}" ]; then
89 exiterror "Not running BASH shell."
90 fi
91
92
93 ############################################################################
94 # #
95 # Trap on emergency exit #
96 # #
97 ############################################################################
98 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
99
100
101 ############################################################################
102 # #
103 # Resetting our nice level #
104 # #
105 ############################################################################
106 echo -ne "Resetting our nice level to $NICE" | tee -a $LOGFILE
107 renice $NICE $$ > /dev/null
108 if [ `nice` != "$NICE" ]; then
109 beautify message FAIL
110 exiterror "Failed to set correct nice level"
111 else
112 beautify message DONE
113 fi
114
115
116 ############################################################################
117 # #
118 # Checking if running as root user #
119 # #
120 ############################################################################
121 echo -ne "Checking if we're running as root user" | tee -a $LOGFILE
122 if [ `id -u` != 0 ]; then
123 beautify message FAIL
124 exiterror "Not building as root"
125 else
126 beautify message DONE
127 fi
128
129
130 ############################################################################
131 # #
132 # Checking for necessary temporary space #
133 # #
134 ############################################################################
135 echo -ne "Checking for necessary space on disk $BASE_DEV" | tee -a $LOGFILE
136 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
137 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
138 if (( 2048000 > $BASE_ASPACE )); then
139 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
140 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
141 beautify message FAIL
142 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
143 fi
144 else
145 beautify message DONE
146 fi
147
148 ############################################################################
149 # #
150 # Building Linux From Scratch system #
151 # #
152 ############################################################################
153 # Set umask
154 umask 022
155
156 # Set LFS Directory
157 LFS=$BASEDIR/build
158
159 # Check /tools symlink
160 if [ -h /tools ]; then
161 rm -f /tools
162 fi
163 if [ ! -a /tools ]; then
164 ln -s $BASEDIR/build/tools /
165 fi
166 if [ ! -h /tools ]; then
167 exiterror "Could not create /tools symbolic link."
168 fi
169
170 # Setup environment
171 set +h
172 LC_ALL=POSIX
173 MAKETUNING="-j6"
174 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
175 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
176
177 # Make some extra directories
178 mkdir -p $BASEDIR/build/{tools,etc,usr/src} 2>/dev/null
179 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
180 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
181 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
182
183 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
184 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
185
186 # Make all sources and proc available under lfs build
187 mount --bind /dev $BASEDIR/build/dev
188 mount --bind /dev/pts $BASEDIR/build/dev/pts
189 mount --bind /dev/shm $BASEDIR/build/dev/shm
190 mount --bind /proc $BASEDIR/build/proc
191 mount --bind /sys $BASEDIR/build/sys
192 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
193 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
194 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
195 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
196 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
197 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
198 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
199 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
200 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
201
202 # This is a temporary hack!!!
203 if [ ! -f /tools/bin/hostname ]; then
204 cp -f /bin/hostname /tools/bin/hostname 2>/dev/null
205 fi
206
207 # Run LFS static binary creation scripts one by one
208 export CCACHE_DIR=$BASEDIR/ccache
209 export CCACHE_HASHDIR=1
210
211 # Remove pre-install list of installed files in case user erase some files before rebuild
212 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
213 }
214
215 buildtoolchain() {
216 LOGFILE="$BASEDIR/log/_build.toolchain.log"
217 export LOGFILE
218 ORG_PATH=$PATH
219 NATIVEGCC=`gcc --version | grep GCC | awk {'print $3'}`
220 export NATIVEGCC GCCmajor=${NATIVEGCC:0:1} GCCminor=${NATIVEGCC:2:1} GCCrelease=${NATIVEGCC:4:1}
221 lfsmake1 ccache
222 lfsmake1 binutils PASS=1
223 lfsmake1 gcc PASS=1
224 export PATH=$BASEDIR/build/usr/local/bin:$BASEDIR/build/tools/bin:$PATH
225 lfsmake1 linux-libc-header
226 lfsmake1 glibc
227 lfsmake1 cleanup-toolchain PASS=1
228 lfsmake1 tcl
229 lfsmake1 expect
230 lfsmake1 dejagnu
231 lfsmake1 gcc PASS=2
232 lfsmake1 binutils PASS=2
233 lfsmake1 ncurses
234 lfsmake1 bash
235 lfsmake1 bzip2
236 lfsmake1 coreutils
237 lfsmake1 diffutils
238 lfsmake1 findutils
239 lfsmake1 gawk
240 lfsmake1 gettext
241 lfsmake1 grep
242 lfsmake1 gzip
243 lfsmake1 m4
244 lfsmake1 make
245 lfsmake1 patch
246 lfsmake1 perl
247 lfsmake1 sed
248 lfsmake1 tar
249 lfsmake1 texinfo
250 lfsmake1 util-linux
251 lfsmake1 cleanup-toolchain PASS=2
252 export PATH=$ORG_PATH
253 }
254
255 buildbase() {
256 LOGFILE="$BASEDIR/log/_build.base.log"
257 export LOGFILE
258 lfsmake2 stage2
259 lfsmake2 linux-libc-header
260 lfsmake2 man-pages
261 lfsmake2 glibc
262 lfsmake2 cleanup-toolchain PASS=3
263 lfsmake2 binutils
264 lfsmake2 gcc
265 lfsmake2 berkeley
266 lfsmake2 coreutils
267 lfsmake2 iana-etc
268 lfsmake2 m4
269 lfsmake2 bison
270 lfsmake2 ncurses
271 lfsmake2 procps
272 lfsmake2 sed
273 lfsmake2 libtool
274 lfsmake2 perl
275 lfsmake2 readline
276 lfsmake2 zlib
277 lfsmake2 autoconf
278 lfsmake2 automake
279 lfsmake2 bash
280 lfsmake2 bzip2
281 lfsmake2 diffutils
282 lfsmake2 e2fsprogs
283 lfsmake2 ed
284 lfsmake2 file
285 lfsmake2 findutils
286 lfsmake2 flex
287 lfsmake2 gawk
288 lfsmake2 gettext
289 lfsmake2 grep
290 lfsmake2 groff
291 lfsmake2 gzip
292 lfsmake2 inetutils
293 lfsmake2 iproute2
294 lfsmake2 kbd
295 lfsmake2 less
296 lfsmake2 libaal
297 lfsmake2 make
298 lfsmake2 man
299 lfsmake2 mktemp
300 lfsmake2 modutils
301 lfsmake2 mtd
302 lfsmake2 net-tools
303 lfsmake2 patch
304 lfsmake2 psmisc
305 lfsmake2 reiser4progs
306 lfsmake2 shadow
307 lfsmake2 sysklogd
308 lfsmake2 sysvinit
309 lfsmake2 tar
310 lfsmake2 texinfo
311 lfsmake2 udev
312 lfsmake2 util-linux
313 lfsmake2 vim
314 lfsmake2 grub
315 }
316
317 buildipfire() {
318 LOGFILE="$BASEDIR/log/_build.ipfire.log"
319 export LOGFILE
320 ipfiremake configroot
321 ipfiremake dhcp
322 ipfiremake dhcpcd
323 ipfiremake libusb
324 ipfiremake libpcap
325 ipfiremake linux-atm
326 ipfiremake ppp
327 ipfiremake rp-pppoe
328 ipfiremake unzip
329 ipfiremake linux SMP=1
330 ipfiremake ipp2p SMP=1
331 ipfiremake fcdsl SMP=1
332 ipfiremake fcdsl2 SMP=1
333 ipfiremake fcdslsl SMP=1
334 ipfiremake fcdslusb SMP=1
335 ipfiremake fcdslslusb SMP=1
336 # ipfiremake promise-sata-300-tx SMP=1
337 ipfiremake zaptel SMP=1
338 ipfiremake fuse SMP=1
339 #ipfiremake linux XEN=1
340 ipfiremake linux
341 ipfiremake ipp2p
342 ipfiremake fcdsl
343 ipfiremake fcdsl2
344 ipfiremake fcdslsl
345 ipfiremake fcdslusb
346 ipfiremake fcdslslusb
347 # ipfiremake promise-sata-300-tx
348 ipfiremake zaptel
349 ipfiremake fuse
350 ipfiremake pkg-config
351 ipfiremake cpio
352 ipfiremake klibc
353 ipfiremake mkinitcpio
354 ipfiremake udev KLIBC=1
355 ipfiremake expat
356 ipfiremake gdbm
357 ipfiremake gmp
358 ipfiremake pam
359 ipfiremake openssl
360 ipfiremake curl
361 ipfiremake python
362 ipfiremake libnet
363 ipfiremake libjpeg
364 ipfiremake libpng
365 ipfiremake libtiff
366 ipfiremake libart
367 ipfiremake freetype
368 ipfiremake gd
369 ipfiremake popt
370 ipfiremake pcre
371 ipfiremake slang
372 ipfiremake newt
373 ipfiremake libcap
374 ipfiremake pciutils
375 ipfiremake libxml2
376 ipfiremake libxslt
377 ipfiremake BerkeleyDB
378 ipfiremake mysql
379 ipfiremake cyrus-sasl
380 ipfiremake openldap
381 ipfiremake apache2
382 ipfiremake php
383 ipfiremake apache2 PASS=C
384 ipfiremake arping
385 ipfiremake beep
386 ipfiremake bind
387 ipfiremake capi4k-utils
388 ipfiremake cdrtools
389 ipfiremake dnsmasq
390 ipfiremake dosfstools
391 ipfiremake reiserfsprogs
392 ipfiremake squashfstools
393 ipfiremake sysfsutils
394 ipfiremake ntfs-3g
395 ipfiremake ethtool
396 ipfiremake ez-ipupdate
397 ipfiremake fcron
398 ipfiremake GD
399 ipfiremake GD-Graph
400 ipfiremake GD-TextUtil
401 ipfiremake gnupg
402 ipfiremake hdparm
403 ipfiremake ibod
404 ipfiremake initscripts
405 ipfiremake whatmask
406 ipfiremake iptables
407 ipfiremake libupnp
408 ipfiremake ipp2p IPT=1
409 ipfiremake moblock
410 ipfiremake linux-igd
411 ipfiremake ipac-ng
412 ipfiremake ipaddr
413 ipfiremake iptstate
414 ipfiremake iputils
415 ipfiremake l7-protocols
416 ipfiremake isdn4k-utils
417 ipfiremake mISDN
418 ipfiremake hwdata
419 ipfiremake kudzu
420 ipfiremake logrotate
421 ipfiremake logwatch
422 ipfiremake misc-progs
423 ipfiremake mtools
424 ipfiremake nano
425 ipfiremake nasm
426 ipfiremake URI
427 ipfiremake HTML-Tagset
428 ipfiremake HTML-Parser
429 ipfiremake Compress-Zlib
430 ipfiremake Digest
431 ipfiremake Digest-SHA1
432 ipfiremake Digest-HMAC
433 ipfiremake libwww-perl
434 ipfiremake Net-DNS
435 ipfiremake Net-IPv4Addr
436 ipfiremake Net_SSLeay
437 ipfiremake IO-Stringy
438 ipfiremake Unix-Syslog
439 ipfiremake Mail-Tools
440 ipfiremake MIME-Tools
441 ipfiremake Net-Server
442 ipfiremake Convert-TNEF
443 ipfiremake Convert-UUlib
444 ipfiremake Archive-Tar
445 ipfiremake Archive-Zip
446 ipfiremake Text-Tabs+Wrap
447 ipfiremake Locale-Country
448 ipfiremake XML-Parser
449 ipfiremake MP3-Info
450 ipfiremake MP3-Tag
451 ipfiremake glib
452 ipfiremake GeoIP
453 ipfiremake fwhits
454 ipfiremake noip_updater
455 ipfiremake ntp
456 ipfiremake openssh
457 ipfiremake openswan
458 ipfiremake pptpclient
459 ipfiremake rrdtool
460 ipfiremake setserial
461 ipfiremake setup
462 ipfiremake snort
463 ipfiremake snortsnarf
464 ipfiremake oinkmaster
465 ipfiremake squid
466 ipfiremake squid-graph
467 ipfiremake squidguard
468 ipfiremake calamaris
469 ipfiremake tcpdump
470 ipfiremake traceroute
471 ipfiremake vlan
472 ipfiremake wireless
473 ipfiremake libsafe
474 ipfiremake 3c5x9setup
475 ipfiremake pakfire
476 ipfiremake java
477 ipfiremake spandsp
478 ipfiremake lzo
479 ipfiremake openvpn
480 ipfiremake pammysql
481 ipfiremake ghostscript
482 ipfiremake cups
483 ipfiremake samba
484 ipfiremake sudo
485 ipfiremake mc
486 ipfiremake wget
487 ipfiremake bridge-utils
488 ipfiremake screen
489 ipfiremake hddtemp
490 ipfiremake smartmontools
491 ipfiremake htop
492 ipfiremake postfix
493 ipfiremake fetchmail
494 ipfiremake cyrusimap
495 ipfiremake webcyradm
496 ipfiremake mailx
497 ipfiremake clamav
498 ipfiremake spamassassin
499 ipfiremake amavisd
500 ipfiremake stund
501 ipfiremake libpri
502 # ipfiremake bristuff
503 ipfiremake asterisk
504 ipfiremake mpg123
505 ipfiremake libmad
506 ipfiremake libogg
507 ipfiremake libvorbis
508 ipfiremake lame
509 ipfiremake sox
510 ipfiremake gnump3d
511 ipfiremake libsigc++
512 ipfiremake ctorrent
513 ipfiremake applejuice
514 ipfiremake ocaml
515 ipfiremake mldonkey
516 ipfiremake libtorrent
517 ipfiremake rtorrent
518 ipfiremake rsync
519 ipfiremake tcpwrapper
520 ipfiremake portmap
521 ipfiremake nfs
522 ipfiremake nmap
523 ipfiremake mbmon
524 ipfiremake iftop
525 ipfiremake ncftp
526 ipfiremake cftp
527 ipfiremake etherwake
528 ipfiremake ethereal
529 ipfiremake tftp-hpa
530 ipfiremake bwm-ng
531 ipfiremake tripwire
532 ipfiremake sysstat
533 ipfiremake vsftpd
534 ipfiremake alsa
535 ipfiremake mp3blaster
536 }
537
538 buildinstaller() {
539 # Run installer scripts one by one
540 LOGFILE="$BASEDIR/log/_build.installer.log"
541 export LOGFILE
542 ipfiremake syslinux
543 ipfiremake as86
544 ipfiremake mbr
545 ipfiremake memtest
546 installmake linux-libc-header
547 installmake binutils
548 ipfiremake uClibc PASS=1
549 ipfiremake gcc INST=1
550 installmake uClibc PASS=2
551 installmake gcc INST=2
552 installmake uClibc PASS=3
553 installmake busybox
554 installmake udev
555 installmake slang
556 installmake newt
557 installmake gettext
558 installmake kbd
559 installmake popt
560 installmake sysvinit
561 installmake misc-progs
562 installmake e2fsprogs
563 installmake libaal
564 installmake reiser4progs
565 installmake reiserfsprogs
566 installmake sysfsutils
567 installmake util-linux
568 installmake pciutils
569 installmake zlib
570 installmake mtd
571 installmake wget
572 installmake hwdata
573 installmake kudzu
574 installmake installer
575 installmake initrd
576 }
577
578 buildpackages() {
579 LOGFILE="$BASEDIR/log/_build.packages.log"
580 export LOGFILE
581 echo "... see detailed log in _build.*.log files" >> $LOGFILE
582
583 installmake strip
584
585 # Generating list of packages used
586 echo -n "Generating packages list from logs" | tee -a $LOGFILE
587 rm -f $BASEDIR/doc/packages-list
588 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
589 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
590 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
591 fi
592 done
593 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
594 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$' \
595 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
596 rm -f $BASEDIR/doc/packages-list
597 # packages-list.txt is ready to be displayed for wiki page
598 beautify message DONE
599
600 # Create images for install
601 if [ "$DEVEL" == "1" ]; then
602 ipfiremake cdrom ED=devel
603 fi
604 ipfiremake cdrom ED=full
605
606 # Check if there is a loop device for building in virtual environments
607 if [ -e /dev/loop0 ]; then
608 ipfiremake usb-stick
609 fi
610 ipfiremake pxe
611 mv $LFS/install/images/{*.iso,*.tgz,*.img.gz} $BASEDIR >> $LOGFILE 2>&1
612
613 ipfirepackages
614
615 # Cleanup
616 stdumount
617 rm -rf $BASEDIR/build/tmp/*
618
619 # Generating total list of files
620 echo -n "Generating files list from logs" | tee -a $LOGFILE
621 rm -f $BASEDIR/log/FILES
622 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
623 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
624 echo "##" >>$BASEDIR/log/FILES
625 echo "## `basename $i`" >>$BASEDIR/log/FILES
626 echo "##" >>$BASEDIR/log/FILES
627 cat $i | sed "s%^\./%#%" | sort >> $BASEDIR/log/FILES
628 fi
629 done
630 beautify message DONE
631
632 cd $PWD
633 }
634
635 ipfirepackages() {
636 ipfiredist alsa
637 # ipfiredist amavisd
638 ipfiredist applejuice
639 # ipfiredist asterisk
640 ipfiredist clamav
641 ipfiredist cups
642 ipfiredist cyrus-sasl
643 # ipfiredist fetchmail
644 # ipfiredist gnump3d
645 ipfiredist java
646 ipfiredist libogg
647 ipfiredist libvorbis
648 # ipfiredist mailx
649 # ipfiredist mldonkey
650 ipfiredist mp3blaster
651 ipfiredist mpg123
652 # ipfiredist nfs
653 ipfiredist openldap
654 # ipfiredist postfix
655 ipfiredist samba
656 # ipfiredist sox
657 # ipfiredist spamassassin
658 ipfiredist tripwire
659 ipfiredist vsftpd
660 # ipfiredist webcyradm
661 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
662 mv -f $LFS/install/packages/* $BASEDIR/packages >> $LOGFILE 2>&1
663 rm -rf $BASEDIR/build/install/packages/*
664 }
665
666 # See what we're supposed to do
667 case "$1" in
668 build)
669 clear
670 BUILDMACHINE=`uname -m`
671 DEVEL=0
672 if [ "$2" == "--devel" ]; then
673 DEVEL=1
674 fi
675 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz 2> /dev/null | head -n 1`
676 #only restore on a clean disk
677 if [ ! -f log/cleanup-toolchain-2-tools ]; then
678 if [ ! -n "$PACKAGE" ]; then
679 beautify build_stage "Full toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
680 prepareenv
681 buildtoolchain
682 else
683 PACKAGENAME=${PACKAGE%.tar.gz}
684 beautify build_stage "Packaged toolchain compilation"
685 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
686 tar zxf $PACKAGE
687 prepareenv
688 else
689 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
690 fi
691 fi
692 else
693 echo -n "Using installed toolchain" | tee -a $LOGFILE
694 beautify message SKIP
695 prepareenv
696 fi
697
698 beautify build_start
699 beautify build_stage "Building LFS"
700 buildbase
701
702 beautify build_stage "Building IPFire"
703 buildipfire
704
705 # Setzen des IPFire Builds
706 if [ "$FIREBUILD" ]; then
707 echo "$FIREBUILD" > $BASEDIR/build/var/ipfire/firebuild
708 else
709 echo "_(OvO)_" > $BASEDIR/build/var/ipfire/firebuild
710 fi
711
712 beautify build_stage "Building installer"
713 buildinstaller
714
715 beautify build_stage "Building packages"
716 buildpackages
717 beautify build_end
718 ;;
719 shell)
720 # enter a shell inside LFS chroot
721 # may be used to changed kernel settings
722 prepareenv
723 entershell
724 ;;
725 changelog)
726 echo -n "Loading new Changelog from SVN: "
727 svn log http://svn.ipfire.org/svn/ipfire > doc/ChangeLog
728 beautify message DONE
729 ;;
730 clean)
731 echo -en "${BOLD}Cleaning build directory...${NORMAL}"
732 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
733 $LOSETUP -d $i 2>/dev/null
734 done
735 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
736 umount $i
737 done
738 stdumount
739 for i in `seq 0 7`; do
740 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
741 umount /dev/loop${i} 2>/dev/null;
742 losetup -d /dev/loop${i} 2>/dev/null;
743 fi;
744 done
745 rm -rf $BASEDIR/build
746 rm -rf $BASEDIR/cdrom
747 rm -rf $BASEDIR/packages
748 rm -rf $BASEDIR/log
749 if [ -h /tools ]; then
750 rm -f /tools
751 fi
752 beautify message DONE
753 ;;
754 downloadsrc)
755 if [ ! -d $BASEDIR/cache ]; then
756 mkdir $BASEDIR/cache
757 fi
758 mkdir -p $BASEDIR/log
759 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
760 FINISHED=0
761 cd $BASEDIR/lfs
762 for c in `seq $MAX_RETRIES`; do
763 if (( FINISHED==1 )); then
764 break
765 fi
766 FINISHED=1
767 cd $BASEDIR/lfs
768 for i in *; do
769 if [ -f "$i" -a "$i" != "Config" ]; then
770 echo -ne "Loading $i"
771 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
772 if [ $? -ne 0 ]; then
773 beautify message FAIL
774 FINISHED=0
775 else
776 if [ $c -eq 1 ]; then
777 beautify message DONE
778 fi
779 fi
780 fi
781 done
782 done
783 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
784 ERROR=0
785 for i in *; do
786 if [ -f "$i" -a "$i" != "Config" ]; then
787 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
788 if [ $? -ne 0 ]; then
789 echo -ne "MD5 difference in lfs/$i"
790 beautify message FAIL
791 ERROR=1
792 fi
793 fi
794 done
795 if [ $ERROR -eq 0 ]; then
796 echo -ne "${BOLD}all files md5sum match${NORMAL}"
797 beautify message DONE
798 else
799 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
800 beautify message FAIL
801 fi
802 cd - >/dev/null 2>&1
803 ;;
804 toolchain)
805 clear
806 prepareenv
807 beautify build_stage "Toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
808 buildtoolchain
809 BUILDMACHINE=`uname -m`
810 echo "`date -u '+%b %e %T'`: Create toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
811 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
812 cd $BASEDIR && tar -zc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
813 build/{bin,etc,usr/bin,usr/local} \
814 build/tools/{bin,etc,*-linux-gnu,include,lib,libexec,sbin,share,var} \
815 log >> $LOGFILE
816 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
817 > cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.md5
818 stdumount
819 ;;
820 gettoolchain)
821 BUILDMACHINE=`uname -m`
822 # arbitrary name to be updated in case of new toolchain package upload
823 PACKAGE=$SNAME-$VERSION-toolchain-$BUILDMACHINE
824 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.gz ]; then
825 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
826 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
827 echo "`date -u '+%b %e %T'`: Load toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
828 cd $BASEDIR/cache/toolchains
829 wget $URL_TOOLCHAIN/$PACKAGE.tar.gz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
830 if [ $? -ne 0 ]; then
831 echo "`date -u '+%b %e %T'`: error downloading toolchain for $BUILDMACHINE machine" | tee -a $LOGFILE
832 else
833 if [ "`md5sum $PACKAGE.tar.gz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
834 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
835 else
836 exiterror "$PACKAGE.md5 did not match, check downloaded package"
837 fi
838 fi
839 else
840 echo "Toolchain is already downloaded. Exiting..."
841 fi
842 ;;
843 othersrc)
844 prepareenv
845 echo -ne "`date -u '+%b %e %T'`: Build sources iso for $MACHINE" | tee -a $LOGFILE
846 chroot $LFS /tools/bin/env -i HOME=/root \
847 TERM=$TERM PS1='\u:\w\$ ' \
848 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin \
849 VERSION=$VERSION NAME="$NAME" SNAME="$SNAME" MACHINE=$MACHINE \
850 /bin/bash -x -c "cd /usr/src/lfs && make -f sources-iso LFS_BASEDIR=/usr/src install" >>$LOGFILE 2>&1
851 mv $LFS/install/images/ipfire-* $BASEDIR >> $LOGFILE 2>&1
852 if [ $? -eq "0" ]; then
853 beautify message DONE
854 else
855 beautify message FAIL
856 fi
857 stdumount
858 ;;
859 svn)
860 case "$2" in
861 update|up)
862 # clear
863 echo -ne "Loading the latest source files...\n"
864 if [ $3 ]; then
865 svn update -r $3 | tee -a $PWD/log/_build.svn.update.log
866 else
867 svn update | tee -a $PWD/log/_build.svn.update.log
868 fi
869 if [ $? -eq "0" ]; then
870 beautify message DONE
871 else
872 beautify message FAIL
873 exit 1
874 fi
875 echo -ne "Writing the svn-info to a file"
876 svn info > $PWD/svn_status
877 if [ $? -eq "0" ]; then
878 beautify message DONE
879 else
880 beautify message FAIL
881 exit 1
882 fi
883 chmod 755 $0
884 exit 0
885 ;;
886 commit|ci)
887 clear
888 if [ -f /usr/bin/mcedit ]; then
889 export EDITOR=/usr/bin/mcedit
890 fi
891 if [ -f /usr/bin/nano ]; then
892 export EDITOR=/usr/bin/nano
893 fi
894 echo -ne "Selecting editor $EDITOR..."
895 beautify message DONE
896 if [ -e /sbin/yast ]; then
897 if [ "`echo $SVN_REVISION | cut -c 3`" -eq "0" ]; then
898 $0 changelog
899 fi
900 fi
901 update_langs
902 svn commit
903 $0 svn up
904 if [ -n "$FTP_CACHE_URL" ]; then
905 $0 uploadsrc
906 fi
907 ;;
908 dist)
909 if [ $3 ]; then
910 SVN_REVISION=$3
911 fi
912 if [ -f ipfire-source-r$SVN_REVISION.tar.gz ]; then
913 echo -ne "REV $SVN_REVISION: SKIPPED!\n"
914 exit 0
915 fi
916 echo -en "REV $SVN_REVISION: Downloading..."
917 svn export http://svn.ipfire.org/svn/ipfire/trunk ipfire-source/ --force > /dev/null
918 svn log http://svn.ipfire.org/svn/ipfire/trunk -r 1:$SVN_REVISION > ipfire-source/Changelog
919 #svn info http://svn.ipfire.org/svn/ipfire/trunk -r $SVN_REVISION > ipfire-source/svn_status
920 evaluate 1
921
922 echo -en "REV $SVN_REVISION: Compressing files..."
923 if [ -e ipfire-source/trunk/make.sh ]; then
924 chmod 755 ipfire-source/trunk/make.sh
925 fi
926 tar cfz ipfire-source-r$SVN_REVISION.tar.gz ipfire-source
927 evaluate 1
928 echo -en "REV $SVN_REVISION: Cleaning up..."
929 rm ipfire-source/ -r
930 evaluate 1
931 ;;
932 diff|di)
933 update_langs
934 echo -ne "Make a local diff to last svn revision"
935 svn diff > ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff
936 evaluate 1
937 echo "Diff was successfully saved to ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff"
938 svn status
939 ;;
940 esac
941 ;;
942 uploadsrc)
943 PWD=`pwd`
944 cd $BASEDIR/cache/
945 echo -e "Uploading cache to ftp server:"
946 ncftpls -u $FTP_CACHE_USER -p $FTP_CACHE_PASS ftp://$FTP_CACHE_URL$FTP_CACHE_PATH/ > /tmp/ftplist
947 for i in *; do
948 if [ "$i" == "toolchains" ]; then continue; fi
949 grep -q $i /tmp/ftplist
950 if [ "$?" -ne "0" ]; then
951 echo -ne "$i"
952 ncftpput -u $FTP_CACHE_USER -p $FTP_CACHE_PASS $FTP_CACHE_URL $FTP_CACHE_PATH/ $i
953 if [ "$?" -ne "0" ]; then
954 beautify message FAIL
955 fi
956 fi
957 done
958 rm -f /tmp/ftplist
959 cd $PWD
960 exit 0
961 ;;
962 upload)
963 case "$2" in
964 iso)
965 echo -e "Uploading the iso to $FTP_ISO_PATH/$SVN_REVISION."
966 cat <<EOF > .ftp-commands
967 mkdir -p $FTP_ISO_PATH$SVN_REVISION
968 ls -lah
969 quit
970 EOF
971 ncftp -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL < .ftp-commands
972 rm -f .ftp-commands
973 md5sum ipfire-$VERSION.$MACHINE-full.iso > ipfire-$VERSION.$MACHINE-full.iso.md5
974 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ ipfire-$VERSION.$MACHINE-full.iso
975 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ ipfire-$VERSION.$MACHINE-full.iso.md5
976 if [ -e ipfire-$VERSION.$MACHINE-devel.iso ]; then
977 md5sum ipfire-$VERSION.$MACHINE-devel.iso > ipfire-$VERSION.$MACHINE-devel.iso.md5
978 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ ipfire-$VERSION.$MACHINE-devel.iso
979 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ ipfire-$VERSION.$MACHINE-devel.iso.md5
980 fi
981 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ ipfire-source-r$SVN_REVISION.tar.gz
982 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/ svn_status
983 if [ "$?" -eq "0" ]; then
984 echo -e "The iso of Revision $SVN_REVISION was successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
985 else
986 echo -e "There was an error while uploading the iso to the ftp server."
987 exit 1
988 fi
989 if [ "$3" = "--with-sources-cd" ]; then
990 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH/$SVN_REVISION/ ipfire-sources-cd-$VERSION.$MACHINE.iso
991 fi
992 ;;
993 paks)
994 cat <<EOF > .ftp-commands
995 mkdir -p $FTP_ISO_PATH$SVN_REVISION/paks
996 ls -lah
997 quit
998 EOF
999 ncftp -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL < .ftp-commands
1000 rm -f .ftp-commands
1001 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH$SVN_REVISION/paks packages/*
1002 if [ "$?" -eq "0" ]; then
1003 echo -e "The packages were successfully uploaded to $FTP_ISO_URL$FTP_ISO_PATH$SVN_REVISION/."
1004 else
1005 echo -e "There was an error while uploading the packages to the ftp server."
1006 exit 1
1007 fi
1008 ;;
1009 esac
1010 ;;
1011 batch)
1012 if [ "$2" = "--background" ]; then
1013 batch_script
1014 exit $?
1015 fi
1016 if [ `screen -ls | grep -q ipfire` ]; then
1017 echo "Build is already running, sorry!"
1018 exit 1
1019 else
1020 if [ "$2" = "--rebuild" ]; then
1021 export IPFIRE_REBUILD=1
1022 echo "REBUILD!"
1023 else
1024 export IPFIRE_REBUILD=0
1025 fi
1026 echo -en "${BOLD}***IPFire-Batch-Build is starting...${NORMAL}"
1027 screen -dmS ipfire $0 batch --background
1028 evaluate 1
1029 exit 0
1030 fi
1031 ;;
1032 watch)
1033 watch_screen
1034 ;;
1035 pxe)
1036 case "$2" in
1037 start)
1038 start_tftpd
1039 ;;
1040 stop)
1041 stop_tftpd
1042 ;;
1043 reload|restart)
1044 reload_tftpd
1045 ;;
1046 esac
1047 exit 0
1048 ;;
1049 lang)
1050 update_langs
1051 ;;
1052 packages)
1053 case "$2" in
1054 sign)
1055 sign_packages
1056 ;;
1057 esac
1058 ;;
1059 "")
1060 clear
1061 svn info
1062 select name in "Exit" "IPFIRE: Downloadsrc" "IPFIRE: Build (silent)" "IPFIRE: Watch Build" "IPFIRE: Batch" "IPFIRE: Clean" "SVN: Commit" "SVN: Update" "SVN: Status" "SVN: Diff" "LOG: Tail" "Help"
1063 do
1064 case $name in
1065 "IPFIRE: Downloadsrc")
1066 $0 downloadsrc
1067 ;;
1068 "IPFIRE: Build (silent)")
1069 $0 build-silent
1070 ;;
1071 "IPFIRE: Watch Build")
1072 $0 watch
1073 ;;
1074 "IPFIRE: Batch")
1075 $0 batch
1076 ;;
1077 "IPFIRE: Clean")
1078 $0 clean
1079 ;;
1080 "SVN: Update")
1081 $0 svn update
1082 ;;
1083 "Help")
1084 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1085 cat doc/make.sh-usage
1086 ;;
1087 "LOG: Tail")
1088 tail -f log/_*
1089 ;;
1090 "Exit")
1091 break
1092 ;;
1093 esac
1094 done
1095 ;;
1096 config)
1097 make_config
1098 ;;
1099 *)
1100 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1101 cat doc/make.sh-usage
1102 ;;
1103 esac